
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <err.h>
#include <errno.h>
#include <netdb.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "rrrdupdate.h"


int
rrrdupdate(char *dest, char *file, char *template, char *fmt, ...)
{
	static int s;
	int error;
	struct sockaddr_in sins;
	static struct sockaddr_in sind;
	struct hostent *hp;
	char *buf1, *buf2, *p, *port, *host;
	va_list ap;

	if (dest != NULL) {
		dest = strdup(dest);
		memset(&sind, 0, sizeof sind);
		sind.sin_family = AF_INET;
		port = strchr(dest, ':');
		if (port != NULL) {
			host = dest;
			*port++ = '\0';
		} else {
			host = NULL;
			port = dest;
		}
		sind.sin_port = htons(strtoul(port, &p, 0));
		if (*port == '\0' || *p != '\0')
			return(-__LINE__);
		if (host == NULL) {
			sins.sin_addr.s_addr = INADDR_LOOPBACK;
			host = "ANY";
		} else {
			hp = gethostbyname(host);
			if (hp == NULL) {
				herror(host);
				return(-__LINE__);
			}
			memcpy(&(sind.sin_addr.s_addr), hp->h_addr, hp->h_length);
		}

		s = socket(AF_INET, SOCK_DGRAM, 0);
		if (s < 0)
			return(-__LINE__);
		
		memset(&sins, 0, sizeof sins);
		sins.sin_family = AF_INET;
		error = bind(s, (struct sockaddr*)&sins, sizeof(sins));
		if (error < 0)
			return(-__LINE__);
	}

	if (fmt == NULL) 
		return (0);

	if (file == NULL || *file == '\0')
		file = "-";
#if 0
	for (p = file; *p; p++) {
		if (!isgraph(*p) || *p == '/')
			return(-__LINE__);
	}
#endif

	if (template == NULL || *template == '\0')
		template = "-";
	
	for (p = template; *p; p++) {
		if (!isgraph(*p))
			return(-__LINE__);
	}

	va_start(ap, fmt);
	error = vasprintf(&buf1, fmt, ap);
	if (error == -1)
		return (error);
	for (p = buf1; *p; p++) {
		if (!isgraph(*p)) {
			free(buf1);
			return(-__LINE__);
		}
	}
	error = asprintf(&buf2, "00 %s %s %s", file, template == NULL ? "-" : template, buf1);
	free(buf1);
	error = sendto(s, buf2, strlen(buf2), 0, (struct sockaddr*)&sind, sizeof(sind));
	free(buf2);
	return (error);
}

